definition module Referee

/**	The referee data type, and all available referees within Soccer-Fun.
*/
import Footballer, GamePicture, matchGame

::	Referee				= E.memory:
							{ name			:: !String
							, brain			:: !Brain (RefereeAI (memory,RandomSeed)) memory
							, refActionPics	:: ![Path]
							}
::	RefereeBrain memory	:== (!memory,!RefereeAI (memory,RandomSeed))
::	RefereeAI state		:==	PlayingTime
							TimeUnit
							FootballState
							Half
							Team
							Team
							state
						->	(![RefereeAction],!state)
instance nameOf Referee

defaultReferee		:: Referee

allAvailableReferees:: [FootballField -> Referee]
defaultImage		:: !Match !RefereeAction !*env -> (!Bitmap,!*env)	| FileSystem env
defaultSoundFile	:: !RefereeAction -> Maybe String

/**	Wrapper functions for simpler referee brains:
*/
randomlessRefereeAI	:: (RefereeAI memory)		-> RefereeAI (memory,RandomSeed)
amnesiaRefereeAI	:: (RefereeAI RandomSeed)	-> RefereeAI (memory,RandomSeed)
witlessRefereeAI	:: (RefereeAI Void)			-> RefereeAI (memory,RandomSeed)
