implementation module Team

import StdEnvExt
import Footballer
import TeamMiniEffie


allAvailableTeams :: [Home FootballField -> Team]
allAvailableTeams		= [ Team_MiniEffies
						  ]


instance nameOf Team where
	nameOf players
		= case players of
			[fb:_]		= nameOf fb.playerID
			none		= abort "nameOf[Team]: applied to empty team.\n"

validateTeam :: !Team -> Team
validateTeam team		= map validateFootballer team
where
	validateFootballer :: !Footballer -> Footballer
	validateFootballer fb=:{length}
		= {fb & length  = setbetween length min_length max_length
		      , stamina = max_stamina
		      , health  = max_health
		  }

isValidTeam :: !Team -> Bool
isValidTeam team		= length clubNames == 1
							&&
						  (isEmpty keepers || isValidKeeper (hd keepers))
							&&
						  all isValidPlayer players
						    &&
						  sort (map nrOf players) == sort (removeDup (map nrOf players))
						    &&
						  not (isMember 1 (map nrOf fielders))
where
	(keepers,fielders)	= spanfilter isKeeper team
	clubNames			= removeDup (map clubOf players)
	clubName			= hd clubNames
	players				= keepers ++ fielders
	clubOf fb			= fb.playerID.clubName
	nrOf   fb			= fb.playerID.playerNr
	isValidKeeper fb	= fb.playerID == {clubName=clubName,playerNr=1}
	isValidPlayer fb	= clubOf fb == clubName

replaceInTeam :: ![Footballer] !Team -> Team
replaceInTeam fbs team	= removeMembers team fbs ++ fbs

instance ==       ATeam where 
	(==) Team1 Team1	= True
	(==) Team2 Team2	= True
	(==) _     _		= False
instance toString ATeam where 
	toString Team1		= "Team1"
	toString Team2		= "Team2"
instance other ATeam where
	other Team1			= Team2
	other Team2			= Team1

getTeam :: !ClubName ![Team] -> Team
getTeam cn teams		= case [team \\ team<-teams | nameOf team==cn] of
							[team:_]	= team
							_			= abort ("Team "<+++cn<+++" does not seem to exist.\n")

instance mirror [a] | mirror a where mirror field as	= map (mirror field) as
instance mirror Footballer     where mirror field fb	= {fb & pos   = mirror field fb.pos
                                                              , nose  = mirror field fb.nose
                                                              , speed = mirror field fb.speed
                                                          }
instance mirror Position       where mirror field pos	= {px = field.flength - pos.px
                                                          ,py = field.fwidth  - pos.py
                                                          }
instance mirror Speed          where mirror field speed	= {speed & direction = mirror field speed.direction}
instance mirror Angle          where mirror field angle	= if (angle >= pi) (3.0*pi - angle) (pi - angle)
