definition module matchGame

/** This module defines the match and tournament data structures.
*/
import matchLog, guiInterface

::	FootballGame
	=	{	match		:: !Match						// the football match to be played
		,	actionPics	:: !ActionPics					// the action-images
		,	history		:: !History						// recent history of game
		,	frames		:: !Int							// nr of frames so far (reset to zero every second)
		,	options		:: !Options						// options of football game
		,	logging		:: !WhatToLog					// logging options
		}

::	Options
	=	{	closeReferee:: !Bool						// automatically close referee dialog after one second (True - default) or by user (False)
		,	showSplash	:: !Bool						// show splash screen at opening (False - default) or do (True)
		, 	displaySpeed:: !DisplaySpeed				// slow, normal or fast-play
		, 	noReferee	:: !Bool						// no referee-intermezzopics should be showed at all
		, 	tournament	:: !Maybe Tournament
		}

::	History
	=	{	time		:: !Seconds						// time in seconds of length history
		,	past		:: ![Match]						// the recent history
		} 
		
:: Tournament		:== [(Team,Team,Score)]
:: TournamentResult	:== [(ClubName,Points)]
:: Points			:== Int

instance toString Tournament
instance toString TournamentResult

makeResult	:: !Tournament -> TournamentResult

incFrames	:: !FootballGame -> FootballGame
