implementation module MiniEffieFootballer

import StdEnv, StdIO
import Footballer, FootballerFunctions

MiniEffie :: ClubName Home FootballField Position PlayersNumber -> Footballer
MiniEffie club home field position nr
	= { playerID		= {clubName=club,playerNr=nr}
	  , name			= "MiniF." <+++ nr
	  , length			= min_length
	  , pos				= position
	  , nose			= zero
	  , speed			= zero
	  , skills			= (Running, Kicking, Rotating)
	  , effect			= Nothing
	  , stamina			= max_stamina
	  , health			= max_health
	  , brain			= { m = {home=home}, ai = onthoud_helft field (minibrain field) }
	  }

onthoud_helft :: FootballField (FootballerAI Memory) (BrainInput Memory) -> BrainOutput Memory
onthoud_helft field brein input
						= brein {input & memory = new_memory}
where
	new_memory			= if (any isEndHalf input.referee) 
						     {home = other input.memory.home}
						     input.memory

:: Memory = { home :: Home
            }

minibrain :: FootballField (BrainInput Memory) -> BrainOutput Memory
minibrain field input	= track_ball input
